﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;
using System.Windows.Controls.Primitives;

namespace WpfApp
{
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
		}

		private void ShowInfo(string message)
		{
			if (this.infoPane != null)
			{
				this.infoPane.Text = message;
			}
		}

		private void RE_Expanded(object sender, RoutedEventArgs e)
		{
			this.ShowInfo("Expanded");
		}

		private void RE_Collapsed(object sender, RoutedEventArgs e)
		{
			this.ShowInfo("Collapsed");
		}

		private void expanderRelated_Click(object sender, RoutedEventArgs e)
		{
			FrameworkElement fe = sender as FrameworkElement;
			RadExpander expander = ((fe != null) ? fe.Tag : null) as RadExpander;
			ToggleButton button = GetExpanderHeader(expander);
			if (button != null)
			{
				button.Focus();
				if (button.IsFocused)
				{
					this.ShowInfo("Focused");
				}
			}
		}

		private static ToggleButton GetExpanderHeader(DependencyObject parent)
		{
			if (parent != null)
			{
				int count = VisualTreeHelper.GetChildrenCount(parent);
				for (int i = 0; i < count; i++)
				{
					DependencyObject obj = VisualTreeHelper.GetChild(parent, i);
					ToggleButton button = obj as ToggleButton;
					if (button != null && button.Name == "HeaderButton")
					{
						return button;
					}
					if (VisualTreeHelper.GetChildrenCount(obj) > 0)
					{
						button = GetExpanderHeader(obj);
						if (button != null)
						{
							return button;
						}
					}
				}
			}
			return null;
		}
	}
}
